'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var reactBootstrap = require('react-bootstrap');
var reactConfirm = require('react-confirm');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

/**
 * A base confirmation class.
 */

var Confirmation =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Confirmation, _React$PureComponent);

  function Confirmation() {
    _classCallCheck(this, Confirmation);

    return _possibleConstructorReturn(this, _getPrototypeOf(Confirmation).apply(this, arguments));
  }

  _createClass(Confirmation, [{
    key: "handleKeyDown",

    /**
     * Handles key down.
     * @param {*} event The event.
     */
    value: function handleKeyDown(event) {
      if (event.target.tagName !== 'BUTTON' && event.keyCode === 13) {
        this.props.proceed();
      }
    }
    /**
     * @override
     */

  }, {
    key: "render",
    value: function render() {
      var _this = this;

      return React.createElement(reactBootstrap.Modal, {
        size: "small",
        show: this.props.show,
        onHide: this.props.cancel,
        backdrop: "static",
        keyboard: this.props.enableEscape,
        onKeyDown: function onKeyDown(event) {
          return _this.handleKeyDown(event);
        },
        centered: true
      }, React.createElement(reactBootstrap.Modal.Header, null, React.createElement(reactBootstrap.Modal.Title, null, this.props.title)), React.createElement(reactBootstrap.Modal.Body, null, this.props.confirmation), React.createElement(reactBootstrap.Modal.Footer, null, React.createElement(reactBootstrap.Button, {
        onClick: this.props.cancel
      }, this.props.closeText), React.createElement(reactBootstrap.Button, {
        variant: this.props.confirmButtonStyle,
        onClick: this.props.proceed
      }, this.props.confirmText)));
    }
  }]);

  return Confirmation;
}(React.PureComponent);

Confirmation.propTypes = {
  /** header title */
  title: PropTypes.string,
  confirmation: PropTypes.string,
  // arguments of your confirm function
  confirmText: PropTypes.string,
  closeText: PropTypes.string,
  confirmButtonStyle: PropTypes.oneOf(['primary', 'success', 'danger', 'warning', 'info', 'default']),
  show: PropTypes.bool,
  // from confirmable. indicates if the dialog is shown or not.
  proceed: PropTypes.func,
  // from confirmable. call to close the dialog with promise resolved.
  cancel: PropTypes.func,
  // from confirmable. call to close the dialog with promise rejected.
  enableEscape: PropTypes.bool
};
Confirmation.defaultProps = {
  title: 'Confirm',
  confirmation: undefined,
  confirmText: 'OK',
  closeText: 'Cancel',
  confirmButtonStyle: 'primary',
  show: undefined,
  proceed: undefined,
  cancel: undefined,
  enableEscape: true
};
var confirm = reactConfirm.createConfirmation(reactConfirm.confirmable(Confirmation));
var index = (function (confirmation) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return confirm(Object.assign({
    confirmation: confirmation
  }, options));
});

module.exports = index;
